anims = {}

function updateAnims(dt)
  local t = dt*60
  for i,a in ipairs(anims) do
    a.t = a.t + a.s * t
    if a.props then
      for _,p in ipairs(a.props) do
        a[p] = lerp(a[p.."1"],a[p.."2"],a.t)
      end
    end
    doex(a.update,a)
    if a.t >= 1 then
      doex(a.onFinish,a)
      table.remove(anims,i)
    end
  end
end

function drawAnims()
  for i,a in ipairs(anims) do
    doex(a.draw,a)
  end
end