local digitMargin = 20
local dy = math.floor(screenH/2-digitH/2)

codeRoom = setmetatable({},room)
codeRoom.__index = codeRoom

function codeRoom.new(correctCode,onSolve,parent,bg)
  assertType(correctCode,"string",1);assertType(onSolve,"function",2);assertType(parent,{"nil","table"},3);assertType(bg,{"nil","Image"},4)
  local obj = setmetatable(room.new(bg),codeRoom)
  obj.correctCode = correctCode
  obj.digits = {}
  for i=1,#correctCode do
    local n = string.byte(string.sub(correctCode,i,i))
    if n < 48 or n > 57 then
      error("all characters in arg #1 are supposed to be numbers!",2)
    end
    local x = math.floor(screenW/2-(digitW+digitMargin)*#correctCode/2+(i-1)*(digitW+digitMargin)+digitMargin/2)
    local d = digit.new(x,dy,obj.digitClicked)
    obj:addObject(d)
    table.insert(obj.digits,d)
  end
  obj.onSolve = onSolve
  if parent then
    obj.parent = parent
    obj:addObject(backButton.new(parent))
  end
  return obj
end

function codeRoom:digitClicked(d)
  for i=1,#self.correctCode do
    if self.digits[i].frameInd-1 ~= tonumber(string.sub(self.correctCode,i,i)) then goto fail end
  end
  doex(self.onSolve)
  ::fail::
end