items = {key={name="key"}}
for _,i in pairs(items) do
  i.img = love.graphics.newImage(imageDir .. "item_" .. i.name .. ".png")
end

inventory = {}

itemSize = 50
inventoryH = 60
maxItems = 10
itemMargin = (screenW-maxItems*itemSize)/(maxItems+1)
selectedItemInd = 0
itemY = math.floor(screenH-inventoryH/2-itemSize/2)

function itemIndToX(i)
  return math.floor((i-1)*(itemSize+itemMargin)+itemMargin)
end

function getItem(item,gx,gy)
  table.insert(inventory,item)
  table.insert(anims,{
      t = 0,
      s = 0.02,
      props = {"x","y"},
      x1 = gx,
      y1 = gy,
      x2 = itemIndToX(#inventory),
      y2 = itemY,
      draw = function(a)
        love.graphics.setColor(0,0,0)
        love.graphics.rectangle("fill",a.x2,a.y2,itemSize,itemSize)
        love.graphics.setColor(1,1,1)
        love.graphics.draw(item.img,a.x,a.y)
      end
    }
  )
end

showInventory = true

function drawInventory()
  if showInventory then
    love.graphics.setColor(0,0,0,0.7)
    love.graphics.rectangle("fill",0,screenH-inventoryH,screenW,inventoryH)
    for i=1,maxItems do
      local dx,dy = itemIndToX(i),itemY
      love.graphics.setColor(0,0,0,1)
      love.graphics.rectangle("fill",dx,dy,itemSize,itemSize)
      if inventory[i] then
        love.graphics.setColor(1,1,1)
        love.graphics.draw(inventory[i].img,dx,dy)
      end
      if i == selectedItemInd then
        love.graphics.setLineWidth(2)
        love.graphics.setColor(1,1,1)
        love.graphics.rectangle("line",dx,dy,itemSize,itemSize)
      end
    end
  end
end