screenW,screenH = love.graphics.getDimensions()

font = love.graphics.setNewFont(30)

imageDir = "images/"

--uutf8 = require "uutf8"

require "locale"

curLang = locale.eng

require "utils"

require "object"

require "digit"

require "room"

require "codeRoom"

require "items"

require "cursors"

require "backButton"

require "messageBar"

require "animations"

--[[backImg = love.graphics.newImage(imageDir .. "backBtn.png")
backBtn = object.new(0,0,"rectangle",{0,screenH-backImg:getHeight()-inventoryH,screenW,backImg:getHeight()},function() gotoRoom(mainRoom); resetCursor() end,backImg)
backBtn.onRollOver = cursors.arrow_down.f
backBtn.onRollOut = resetCursor]]

gotoLeftObj = object.new(0,0,"polygon",{64,438,162,385,213,389,207,433,142,498,61,487},function() gotoRoom(leftRoom); resetCursor() end)
gotoLeftObj.onRollOver = cursors.arrow_up.f
gotoLeftObj.onRollOut = resetCursor

gotoRightObj = object.new(0,0,"polygon",{433,394,483,390,578,445,581,491,504,499,439,431},function() gotoRoom(rightRoom); resetCursor() end)
gotoRightObj.onRollOver = cursors.arrow_up.f
gotoRightObj.onRollOut = resetCursor

gotoBoxObj = object.new(200,224,"polygon",{3,30,53,1,227,40,227,98,176,140,6,108},function() gotoRoom(boxRoom); resetCursor() end,{love.graphics.newImage(imageDir .. "box_closed.png"),love.graphics.newImage(imageDir .. "box_open.png")})
gotoBoxObj.onRollOver = cursors.hand.f
gotoBoxObj.onRollOut = resetCursor

gotoDoorRoom = object.new(0,0,"rectangle",{293,265,90,164},function() gotoRoom(doorRoom); if doorRoom.bg == doorRoomBG1 then resetCursor() else doorObject.over = true end end,{love.graphics.newImage(imageDir .. "mainDoor_1.png"),love.graphics.newImage(imageDir .. "mainDoor_2.png")})
gotoDoorRoom.onRollOver = cursors.arrow_up.f
gotoDoorRoom.onRollOut = resetCursor

keyPickupImg = love.graphics.newImage(imageDir .. "key_pickup.png")
keyPickup = object.new(243,300,"rectangle",{0,0,keyPickupImg:getDimensions()},function(o) o.parent.objects[o] = nil; getItem(items.key,o.x,o.y); resetCursor() end,keyPickupImg)
keyPickup.onRollOver = cursors.hand.f
keyPickup.onRollOut = resetCursor

doorObject = object.new(163,92,"rectangle",{0,0,260,429-33},function(o)
    if doorRoom.bg == doorRoomBG1 then
      if inventory[selectedItemInd] == items.key then
        messageBar.setMessage(curLang.doorOpen)
        doorRoom.bg = doorRoomBG2
        gotoDoorRoom.frameInd = 2
        --mainRoom.bg = mainRoomBG2
        o.onRollOver = cursors.arrow_up.f
        o.onRollOut = resetCursor
        table.remove(inventory,selectedItemInd)
        cursors.arrow_up.f()
      else
        messageBar.setMessage(curLang.doorLocked)
      end
    else
      showInventory = false
      gotoRoom(winRoom)
      resetCursor()
    end
  end
)

mainRoomBG1 = love.graphics.newImage(imageDir .. "testRoom_a.png")
--mainRoomBG2 = love.graphics.newImage(imageDir .. "testRoom_a2.png")
doorRoomBG1 = love.graphics.newImage(imageDir .. "testRoom_c.png")
doorRoomBG2 = love.graphics.newImage(imageDir .. "testRoom_c2.png")

mainRoom = room.new(mainRoomBG1,{gotoLeftObj,gotoRightObj,gotoDoorRoom})
mainRoom.name = "main"

backToMain = backButton.new(mainRoom)

leftRoom = room.new(love.graphics.newImage(imageDir .. "testRoom_b.png"),{backToMain})
leftRoom.name = "table left"

rightRoom = room.new(love.graphics.newImage(imageDir .. "testRoom_d.png"),{backToMain,gotoBoxObj})
rightRoom.name = "table right"

boxRoom = codeRoom.new("4695",function()
    --rightRoom.objects[gotoBoxObj] = nil
    gotoBoxObj.x,gotoBoxObj.y = 204,170
    gotoBoxObj.frameInd = 2
    gotoBoxObj.onClick = function() gotoRoom(insideBoxRoom); resetCursor() end
    gotoBoxObj:moveShape(-4,57)
    gotoBoxObj.onRollOver = cursors.arrow_up.f
    gotoRoom(rightRoom)
  end,rightRoom,love.graphics.newImage(imageDir .. "testRoom_e.png"))
boxRoom.onEnter = function(r) for _,d in ipairs(r.digits) do d.frameInd = 1 end end
boxRoom.name = "box code"

insideBoxRoom = room.new(love.graphics.newImage(imageDir .. "inside_box.png"),{keyPickup,backButton.new(rightRoom)})
insideBoxRoom.name = "inside box"

doorRoom = room.new(doorRoomBG1,{backToMain,doorObject})
doorRoom.name = "door"

winRoom = room.new(love.graphics.newImage(imageDir .. "winRoom.png"))
winRoom.name = "win"

curRoom = mainRoom

function gotoRoom(r)
  curRoom = r
  r:mousemoved(love.mouse.getPosition())
  doex(r.onEnter,r)
end

function love.mousepressed(x,y,b)
  if y >= screenH-inventoryH and showInventory then
    --this should probably be moved to items.lua
    local i = math.ceil(x/(itemSize+itemMargin))
    if i == selectedItemInd then
      selectedItemInd = 0
    elseif inventory[i] then
      selectedItemInd = i
    end
  else
    curRoom:mousepressed(x,y,b)
  end
end

function love.mousemoved(x,y,dx,dy)
  curRoom:mousemoved(x,y,dx,dy)
end

function love.update(dt)
  messageBar.update(dt)
  updateAnims(dt)
end

function love.keypressed(k)
  if love.keyboard.isDown("lctrl") and k == "d" then debugDraw = not debugDraw end
end

function love.draw()
  love.graphics.setColor(1,1,1)
  curRoom:draw()
  drawInventory()
  messageBar.draw()
  drawAnims()
  love.graphics.setColor(0,0,0)
  --love.graphics.print(curRoom.name or "")
  --love.graphics.print(tostring(messageBar.active) .. " " .. messageBar.timer)
end