messageBar = {}

messageBar.active = false

messageBar.h = font:getHeight()

messageBar.dy = -messageBar.h
messageBar.y = messageBar.dy

messageBar.text = ""

messageBar.timer = 0
messageBar.speed = 0.005
messageBar.start = 0.1
messageBar.finish = 0.9

function messageBar.setMessage(t)
  if messageBar.active then
    messageBar.timer = messageBar.start
    table.insert(anims,{
        props = {"y"},
        y1 = messageBar.h,
        y2 = messageBar.h+20,
        y = messageBar.h,
        t = 0,
        s = 0.02,
        draw = function(a)
          love.graphics.setColor(0,0,0,1-a.t)
          love.graphics.line(0,a.y,screenW,a.y)
        end
      }
    )
  else
    messageBar.active = true
    messageBar.y = messageBar.dy
    messageBar.timer = 0
  end
  messageBar.text = t
end

function messageBar.update(dt)
  if messageBar.active then
    local t = dt*60
    messageBar.timer = messageBar.timer + messageBar.speed * t
    if messageBar.timer <= messageBar.start then
      messageBar.y = lerp(0,messageBar.dy,(messageBar.start-messageBar.timer)/(messageBar.start))
    elseif messageBar.timer >= 1 then
      messageBar.active = false
    elseif messageBar.timer >= messageBar.finish then
      messageBar.y = lerp(0,messageBar.dy,(messageBar.timer-messageBar.finish)/(1-messageBar.finish))
    else
      messageBar.y = 0
    end
  end
end

function messageBar.draw()
  if messageBar.active then
    love.graphics.setColor(0,0,0,0.6)
    love.graphics.rectangle("fill",0,messageBar.y,screenW,messageBar.h)
    love.graphics.setColor(1,1,1)
    love.graphics.printf(messageBar.text,0,messageBar.y,screenW,"center")
  end
end