room = {}
room.__index = room

function room.new(bg,objects)
  objects = objects or {}
  assertType(bg,{"nil","Image"},1); assertType(objects,"table",2)
  local obj = setmetatable({},room)
  obj.bg = bg
  --obj.objects = objects
  obj.objects = {}
  for _,o in ipairs(objects) do
    obj:addObject(o)
  end
  return obj
end

function room:addObject(o)
  o.parent = self
  --table.insert(self.objects,o)
  self.objects[o] = o
end

function room:doSub(f,...) -- does f(...) on all of the room's objects
  --for _,o in ipairs(self.objects) do
  for _,o in pairs(self.objects) do
    o[f](o,...) -- this is assuming all object's functions are methods (called with the ':' operator)
  end
end

function room:mousepressed(x,y,b)
  self:doSub("mousepressed",x,y,b)
  selectedItemInd = 0
end

function room:mousemoved(x,y,dx,dy)
  self:doSub("mousemoved",x,y,dx,dy)
end

function room:draw()
  love.graphics.setColor(1,1,1)
  if self.bg then love.graphics.draw(self.bg) end
  self:doSub("draw")
end